<?php

declare(strict_types=1);

namespace Dedi\SyliusAdvertisingPlugin\Entity;

use Doctrine\ORM\Mapping as ORM;
use Sylius\Component\Core\Model\ImageInterface;

/**
 * @ORM\Entity()
 * @ORM\Table(name="dedi_advertising_image")
 */
class AdvertisingImage implements ImageInterface
{
    const TYPE = 'dedi_advertising_image';
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue(strategy="AUTO")
     * @ORM\Column(name="id", type="integer", unique=true)
     */
    protected ?int $id = null;

    /**
     * @ORM\OneToOne(targetEntity="Dedi\SyliusAdvertisingPlugin\Entity\Advertising", inversedBy="image")
     * @ORM\JoinColumn(name="owner_id", referencedColumnName="id")
     */
    protected ?object $owner = null;

    /**
     * @ORM\Column(type="string", nullable=false, name="image_path")
     */
    protected ?string $path = null;

    protected ?\SplFileInfo $file = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFile(): ?\SplFileInfo
    {
        return $this->file;
    }

    public function setFile(?\SplFileInfo $file): void
    {
        $this->file = $file;
    }

    public function hasFile(): bool
    {
        return null !== $this->file;
    }

    public function getPath(): ?string
    {
        return $this->path;
    }

    public function setPath(?string $path): void
    {
        $this->path = $path;
    }

    public function getOwner()
    {
        return $this->owner;
    }

    public function setOwner($owner): void
    {
        $this->owner = $owner;
    }

    public function getType(): ?string
    {
        return self::TYPE;
    }

    public function setType(?string $type): void
    {
    }
}
