<?php

namespace Dedi\SyliusAdvertisingPlugin\Entity;

use Dedi\SyliusAdvertisingPlugin\Domain\Advertising\Adapter\AdvertisingZoneInterface as BaseAdvertisingZoneInterfaceAlias;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ChannelInterface;
use Sylius\Component\Resource\Model\ResourceInterface;

interface AdvertisingZoneInterface extends ResourceInterface, BaseAdvertisingZoneInterfaceAlias
{
    public function setCode(string $code): self;

    public function setEnabled(bool $enabled): self;

    public function hasAdvertising(): bool;

    public function addAdvertising(AdvertisingInterface $advertising): bool;

    public function removeAdvertising(AdvertisingInterface $advertising): bool;

    public function getChannels(): Collection;

    public function setChannels(Collection $channels): self;

    public function addChannel(ChannelInterface $channel): bool;

    public function removeChannel(ChannelInterface $channel): bool;
}
